/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.12 by edhill, Thu Oct 9 04:19:20 2003 UTC revision 1.28 by edhill, Tue Nov 4 19:51:54 2003 UTC
# Line 46  expand_pkg_groups() { Line 46  expand_pkg_groups() {
46      PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"      PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
47      if test -r $PKG_GROUPS ; then      if test -r $PKG_GROUPS ; then
48          cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp          cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
49          cat ./p1.tmp | awk '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp          cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
50          matched=0          matched=0
51          for i in $PACKAGES ; do          for i in $PACKAGES ; do
52              line=`grep "^ *$i" ./p2.tmp`              line=`grep "^ *$i" ./p2.tmp`
53              RETVAL=$?              RETVAL=$?
54              if test "x$RETVAL" = x0 ; then              if test "x$RETVAL" = x0 ; then
55                  matched=1                  matched=1
56                  replace=`echo $line | awk '{ $1=""; $2=""; print $0 }'`                  replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
57                  echo "    replacing \"$i\" with: $replace"                  echo "    replacing \"$i\" with: $replace"
58                  new_packages="$new_packages $replace"                  new_packages="$new_packages $replace"
59              else              else
# Line 72  find_possible_configs()  { Line 72  find_possible_configs()  {
72    
73      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
74      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
75      PLATFORM=`echo $tmp2 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
76        PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
77      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
78      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
79  #     if test "x$OFLIST" = x ; then  #     if test "x$OFLIST" = x ; then
# Line 104  find_possible_configs()  { Line 105  find_possible_configs()  {
105      fi      fi
106    
107      # look for possible fortran compilers      # look for possible fortran compilers
108      tmp="$MITGCM_FC $FC g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
109      p_FC=      p_FC=
110      for c in $tmp ; do      for c in $tmp ; do
111          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 121  EOF Line 122  EOF
122              p_FC="$p_FC $c"              p_FC="$p_FC $c"
123          fi          fi
124      done      done
125        rm -f ./hello.f ./hello
126      if test "x${p_FC}" = x ; then      if test "x${p_FC}" = x ; then
127          cat 1>&2 <<EOF          cat 1>&2 <<EOF
128    
# Line 136  EOF Line 138  EOF
138          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
139          echo "   "$p_FC          echo "   "$p_FC
140          if test "x$FC" = x ; then          if test "x$FC" = x ; then
141              FC=`echo $p_FC | awk '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
142          fi          fi
143      fi      fi
144    
# Line 202  get_pdepend_list()  { Line 204  get_pdepend_list()  {
204      #  strip the comments and then convert the dependency file into      #  strip the comments and then convert the dependency file into
205      #  two arrays: PNAME, DNAME      #  two arrays: PNAME, DNAME
206      cat $1 | sed -e 's/#.*$//g' \      cat $1 | sed -e 's/#.*$//g' \
207          | awk 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \          | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
208          > ./.pd_tmp          > ./.pd_tmp
209      source ./.pd_tmp      source ./.pd_tmp
210      rm -f ./.pd_tmp      rm -f ./.pd_tmp
# Line 319  STANDARDDIRS= Line 321  STANDARDDIRS=
321    
322  PWD=`pwd`  PWD=`pwd`
323  MAKE=make  MAKE=make
324    AWK=awk
325  THISHOSTNAME=`hostname`  THISHOSTNAME=`hostname`
326  THISCWD=`pwd`  THISCWD=`pwd`
327  THISDATE=`date`  THISDATE=`date`
# Line 332  if test "x$MITGCM_IEEE" != x ; then Line 335  if test "x$MITGCM_IEEE" != x ; then
335      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
336  fi  fi
337    
338    AUTODIFF_PKG_USED=f
339    AD_OPTFILE=
340    TAF=
341    AD_TAF_FLAGS=
342    FTL_TAF_FLAGS=
343    SVD_TAF_FLAGS=
344    TAF_EXTRA=
345    TAMC=
346    AD_TAMC_FLAGS=
347    FTL_TAF_FLAGS=
348    SVD_TAMC_FLAGS=
349    TAMC_EXTRA=
350    
351    
352  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
353  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"
354  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"
# Line 342  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFI Line 359  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFI
359  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
360  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
361    
362  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6"  #  The following are all related to adjoint/tangent-linear stuff
363    gm_s7="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
364    gm_s8="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
365    gm_s9="TAF_EXTRA TAMC_EXTRA"
366    
367    gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7 $gm_s8 $gm_s9"
368    
369    
370  echo  echo
# Line 375  fi Line 397  fi
397  #   n=$(( $n + 1 ))  #   n=$(( $n + 1 ))
398  #done  #done
399  #parse_options  #parse_options
   
400  ac_prev=  ac_prev=
401  for ac_option ; do  for ac_option ; do
402    
# Line 400  for ac_option ; do Line 421  for ac_option ; do
421          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
422              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
423                    
424            -adoptfile | --adoptfile | -ad | --ad)
425                ac_prev=AD_OPTFILE ;;
426            -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
427                AD_OPTFILE=$ac_optarg ;;
428            
429          -pdepend | --pdepend)          -pdepend | --pdepend)
430              ac_prev=PDEPEND ;;              ac_prev=PDEPEND ;;
431          -pdepend=* | --pdepend=*)          -pdepend=* | --pdepend=*)
# Line 483  for ac_option ; do Line 509  for ac_option ; do
509          -ds | --ds)          -ds | --ds)
510              DUMPSTATE=t ;;              DUMPSTATE=t ;;
511                    
512            -taf_extra | --taf_extra)
513                ac_prev=TAF_EXTRA ;;
514            -taf_extra=* | --taf_extra=*)
515                TAF_EXTRA=$ac_optarg ;;
516    
517            -tamc_extra | --tamc_extra)
518                ac_prev=TAMC_EXTRA ;;
519            -tamc_extra=* | --tamc_extra=*)
520                TAMC_EXTRA=$ac_optarg ;;
521    
522          -*)          -*)
523              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
524              usage              usage
# Line 563  if test "x$OPTFILE" != xNONE ; then Line 599  if test "x$OPTFILE" != xNONE ; then
599      fi      fi
600  fi  fi
601    
602    echo "  getting AD_OPTFILE information:  "
603    if test "x${AD_OPTFILE}" = x ; then
604        if test "x$MITGCM_AD_OF" = x ; then
605            AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
606        else
607            AD_OPTFILE=$MITGCM_AD_OF
608        fi
609    fi
610    if test "x${AD_OPTFILE}" != xNONE ; then
611        if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
612            echo "    using AD_OPTFILE=\"$AD_OPTFILE\""
613            source "$AD_OPTFILE"
614            RETVAL=$?
615            if test "x$RETVAL" != x0 ; then
616                echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
617                echo "--please check that variable syntax is bash-compatible"
618                exit 1
619            fi
620            if test "x$DUMPSTATE" != xf ; then
621                cp -f $AD_OPTFILE "genmake_ad_optfile"
622            fi
623        else
624            echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
625            exit 1
626        fi
627    fi
628    
629  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain  #  Check that FC, LINK, CPP, and S64 are defined.  If not, complain
630  #  and abort!  #  and abort!
631  if test "x$FC" = x ; then  if test "x$FC" = x ; then
# Line 581  fi Line 644  fi
644  if test "x$CPP" = x ; then  if test "x$CPP" = x ; then
645      CPP="cpp"      CPP="cpp"
646  fi  fi
647  echo "#define A a" | cpp > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
648  RETVAL=$?  RETVAL=$?
649  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
650      cat <<EOF 1>&2      cat <<EOF 1>&2
# Line 682  echo "  getting package dependency info Line 745  echo "  getting package dependency info
745  #  Strip the comments and then convert the dependency file into  #  Strip the comments and then convert the dependency file into
746  #  two arrays: PNAME, DNAME  #  two arrays: PNAME, DNAME
747  cat $PDEPEND | sed -e 's/#.*$//g' \  cat $PDEPEND | sed -e 's/#.*$//g' \
748      | awk 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \      | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
749      > ./.pd_tmp      > ./.pd_tmp
750  RETVAL=$?  RETVAL=$?
751  if test ! "x${RETVAL}" = x0 ; then  if test ! "x${RETVAL}" = x0 ; then
# Line 716  else Line 779  else
779      else      else
780          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "  using PDEFAULT=\"$PDEFAULT\""
781          #  Strip the comments and add all the names          #  Strip the comments and add all the names
782          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | awk '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
783          RETVAL=$?          RETVAL=$?
784          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
785              echo -n "Error: can't parse default package list "              echo -n "Error: can't parse default package list "
# Line 838  for i in $PACKAGES ; do Line 901  for i in $PACKAGES ; do
901      if test -d $adr ; then      if test -d $adr ; then
902          SOURCEDIRS="$SOURCEDIRS $adr"          SOURCEDIRS="$SOURCEDIRS $adr"
903          INCLUDEDIRS="$INCLUDEDIRS $adr"          INCLUDEDIRS="$INCLUDEDIRS $adr"
904            if test "x$i" = xautodiff ; then
905                AUTODIFF_PKG_USED=t
906            fi
907      else      else
908          echo "Error: the directory \"$adr\" for package $i doesn't exist"          echo "Error: the directory \"$adr\" for package $i doesn't exist"
909          exit 1          exit 1
910      fi      fi
911  done  done
912    
 #  This is compatible with the old genmake.  The "DISABLE_*" flags  
 #  need to be replaced by the "ALLOW_*" flags set below.  
 #  
 # echo -n "  Setting package-specific CPP flags:  "  
 # pkrm=( mom_fluxform mom_vecinv generic_advdiff )  
 # pkrmdef=( -DDISABLE_MOM_FLUXFORM -DDISABLE_MOM_VECINV -DDISABLE_GENERIC_ADVDIFF -DDISABLE_DEBUGMODE )  
 # echo -n "  "  
 # i=0  
 # while test $i -lt "${#pkrm[@]}" ; do  
 #     echo "$PACKAGES" | grep "${pk[$i]}" > /dev/null 2>&1  
 #     RETVAL=$?  
 #     if test "x$RETVAL" = x1 ; then  
 #       DEFINES="$DEFINES ${pkdef[$i]}"  
 #       echo -n " ${pkdef[$i]}"  
 #     fi  
 #     i=$(( $i + 1 ))  
 # done  
 # echo  
913    
914  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
915  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
# Line 893  for n in $names ; do Line 941  for n in $names ; do
941              fi              fi
942          done          done
943          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
944              undef=`echo "ALLOW_$n" | awk '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
945              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"
 #           DEFINES="$DEFINES -U$undef"  
   
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
             case $n in  
                 mom_fluxform)  
                     DEFINES="$DEFINES -DDISABLE_MOM_FLUXFORM"  
                     ;;  
                 mom_vecinv)  
                     DEFINES="$DEFINES -DDISABLE_MOM_VECINV"  
                     ;;  
                 debug)  
                     DEFINES="$DEFINES -DDISABLE_DEBUGMODE"  
                     ;;  
             esac  
 #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  
   
946          fi          fi
947      fi      fi
948  done  done
# Line 919  cat <<EOF >>$PACKAGES_DOT_H".tmp" Line 951  cat <<EOF >>$PACKAGES_DOT_H".tmp"
951  C  Packages enabled by genmake:  C  Packages enabled by genmake:
952  EOF  EOF
953  for i in $PACKAGES ; do  for i in $PACKAGES ; do
954      def=`echo "ALLOW_$i" | awk '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
955      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      echo "#define $def" >> $PACKAGES_DOT_H".tmp"
956  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
957    
# Line 976  for d in $STANDARDDIRS ; do Line 1008  for d in $STANDARDDIRS ; do
1008      fi      fi
1009  done  done
1010    
1011  echo " Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"
1012  echo " of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"
1013  CPP_OPTIONS=  CPP_OPTIONS=
1014  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1015  for i in $spaths ; do  for i in $spaths ; do
# Line 1000  for n in $names ; do Line 1032  for n in $names ; do
1032  done  done
1033    
1034    
1035    #  Here, we build the list of files to be "run through" the adjoint
1036    #  compiler.
1037    if test -f ./ad_files ; then
1038        rm -f ./ad_files
1039    fi
1040    echo "  Creating the list of files for the adjoint compiler."
1041    for i in $SOURCEDIRS ; do
1042        list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
1043        for j in $list_files ; do
1044            cat $i/$j >> ad_files
1045        done
1046    done
1047    
1048    cat <<EOF > adjoint_sed
1049    s/call adopen(/call adopen ( mythid,\\
1050         \&           /g
1051    s/call adclose(/call adclose( mythid,\\
1052         \&           /g
1053    s/call adread(/call adread ( mythid,\\
1054         \&           /g
1055    s/call adwrite(/call adwrite( mythid,\\
1056         \&           /g
1057    
1058    EOF
1059    
1060  echo  echo
1061  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1062  echo "  setting INCLUDES"  echo "  setting INCLUDES"
# Line 1020  echo -n 'SRCFILES = '    > srclist.inc Line 1077  echo -n 'SRCFILES = '    > srclist.inc
1077  echo -n 'CSRCFILES = '   > csrclist.inc  echo -n 'CSRCFILES = '   > csrclist.inc
1078  echo -n 'F90SRCFILES = ' > f90srclist.inc  echo -n 'F90SRCFILES = ' > f90srclist.inc
1079  echo -n 'HEADERFILES = ' > hlist.inc  echo -n 'HEADERFILES = ' > hlist.inc
1080    echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc
1081  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1082  for d in $alldirs ; do  for d in $alldirs ; do
1083      deplist=      deplist=
1084      sfiles=`( cd $d; echo *.[h,c,F] )`      sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
1085      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`      sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
1086      for sf in $sfiles ; do      for sf in $sfiles ; do
1087          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1088              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1089                  extn=`echo $sf | awk -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
1090                  touch .links.tmp/$sf                  touch .links.tmp/$sf
1091                  deplist="$deplist $sf"                  deplist="$deplist $sf"
1092                  case $extn in                  case $extn in
# Line 1048  for d in $alldirs ; do Line 1106  for d in $alldirs ; do
1106                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1107                          echo -n " $sf" >> hlist.inc                          echo -n " $sf" >> hlist.inc
1108                          ;;                          ;;
1109                        flow)
1110                            echo    " \\"  >> ad_flow_files.inc
1111                            echo -n " $sf" >> ad_flow_files.inc
1112                            ;;
1113                  esac                  esac
1114              fi              fi
1115          fi          fi
# Line 1064  echo "" >> srclist.inc Line 1126  echo "" >> srclist.inc
1126  echo "" >> csrclist.inc  echo "" >> csrclist.inc
1127  echo "" >> f90srclist.inc  echo "" >> f90srclist.inc
1128  echo "" >> hlist.inc  echo "" >> hlist.inc
1129    echo "" >> ad_flow_files.inc
1130    
1131  if test -e $MAKEFILE ; then  if test -e $MAKEFILE ; then
1132      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
# Line 1077  echo "# by the command:" >> $MAKEFILE Line 1140  echo "# by the command:" >> $MAKEFILE
1140  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $@" >> $MAKEFILE
1141  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1142  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1143    
1144    EXE_AD=$EXECUTABLE"_ad"
1145    EXE_FTL=$EXECUTABLE"_ftl"
1146    EXE_SVD=$EXECUTABLE"_svd"
1147    
1148  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1149  #  #
1150  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
# Line 1105  EXEDIR      = ${EXEDIR} Line 1173  EXEDIR      = ${EXEDIR}
1173  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}  EXECUTABLE  = \$(EXEDIR)/${EXECUTABLE}
1174  TOOLSDIR    = ${TOOLSDIR}  TOOLSDIR    = ${TOOLSDIR}
1175    
1176    #eh3  new defines for the adjoint work
1177    AUTODIFF    = ${ROOTDIR}/pkg/autodiff
1178    EXE_AD      = ${EXE_AD}
1179    EXE_FTL     = ${EXE_FTL}
1180    EXE_SVD     = ${EXE_SVD}
1181    
1182  EOF  EOF
1183    
1184  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1150  MAKEFILE=${MAKEFILE} Line 1224  MAKEFILE=${MAKEFILE}
1224    
1225  EOF  EOF
1226    
1227  cat srclist.inc    >> $MAKEFILE  cat srclist.inc       >> $MAKEFILE
1228  cat csrclist.inc   >> $MAKEFILE  cat csrclist.inc      >> $MAKEFILE
1229  cat f90srclist.inc >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1230  cat hlist.inc      >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1231    cat ad_flow_files.inc >> $MAKEFILE
1232    echo               >> $MAKEFILE
1233  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE
1234  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE
1235  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1236    
1237  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1238    rm -f ad_flow_files.inc
1239    
1240  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1241    
# Line 1182  output.txt: \$(EXECUTABLE) Line 1259  output.txt: \$(EXECUTABLE)
1259          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1260    
1261  clean:  clean:
1262            -cat AD_CONFIG.template > AD_CONFIG.h
1263          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}
1264  Clean:  Clean:
1265          @make clean          @make clean
1266          @make cleanlinks          @make cleanlinks
1267          -rm -f Makefile.bak genmake_state genmake_optfile make.log          -rm -f Makefile.bak genmake_state genmake_*optfile make.log
1268  CLEAN:  CLEAN:
1269          @make Clean          @make Clean
1270          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1194  CLEAN: Line 1272  CLEAN:
1272          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1273          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt
1274    
1275    #eh3 Makefile: makefile
1276  makefile:  makefile:
1277          ${0} $@          ${0} $@
1278  cleanlinks:  cleanlinks:
# Line 1217  cleanlinks: Line 1296  cleanlinks:
1296  .p.f:  .p.f:
1297          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1298    
1299    #=========================================
1300    #===  Automatic Differentiation Rules  ===
1301    
1302    TAMC           = ${TAMC}
1303    TAF            = ${TAF}
1304    
1305    TAF_EXTRA      = ${TAF_EXTRA}
1306    TAMC_EXTRA     = ${TAMC_EXTRA}
1307    
1308    EOF
1309    
1310    ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
1311    ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
1312    ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1313    for i in $ad_vars ; do
1314        name=$i
1315        t1="t2=\$"`echo $i`
1316        eval $t1
1317        printf "%-20s = " $name >> $MAKEFILE
1318        echo $t2 >> $MAKEFILE
1319    done
1320    
1321    echo "  Add the source list for AD code generation"
1322    echo >> $MAKEFILE
1323    echo -n "AD_FILES = " >> $MAKEFILE
1324    AD_FILES=`cat ad_files`
1325    for i in $AD_FILES ; do
1326        echo    " \\" >> $MAKEFILE
1327        echo -n " $i" >> $MAKEFILE
1328    done
1329    echo >> $MAKEFILE
1330    rm -f ad_files
1331    
1332    cat >>$MAKEFILE <<EOF
1333    
1334    # ... AD ...
1335    adall: ad_taf
1336    adtaf: ad_taf_output.f
1337    adtamc: ad_tamc_output.f
1338    
1339    ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1340            cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1341            @make \$(F77FILES)
1342            @make \$(AD_FLOW_FILES)
1343            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1344    
1345    ad_taf_output.f: ad_input_code.f
1346            \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1347            cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f
1348    
1349    ad_taf: ad_taf_output.o \$(OBJFILES)
1350            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1351    
1352    ad_tamc_output.f: ad_input_code.f
1353            \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1354            cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f
1355    
1356    ad_tamc: ad_tamc_output.o \$(OBJFILES)
1357            \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
1358    
1359    
1360    # ... FTL ...
1361    ftlall: ftl_taf
1362    ftltaf: ftl_taf_output.f
1363    ftltamc: ftl_tamc_output.f
1364    
1365    ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1366            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1367            @make \$(F77FILES)
1368            @make \$(AD_FLOW_FILES)
1369            cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1370    
1371    ftl_taf_output.f: ftl_input_code.f
1372            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1373            cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f
1374    
1375    ftl_taf: ftl_taf_output.o \$(OBJFILES)
1376            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1377    
1378    ftl_tamc_output.f: ftl_input_code.f
1379            \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1380            cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f
1381    
1382    ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1383            \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1384    
1385    
1386    # ... SVD ...
1387    svd: svd_taf
1388    svd_taf_f: svd_taf_output.f
1389    
1390    svd_input_code.f: \$(SRCFILES)
1391            cmp svd_config.template AD_CONFIG.h || cat svd_config.template > AD_CONFIG.h
1392            @make \$(F77FILES)
1393            @make \$(AD_FLOW_FILES)
1394            cat \$(AD_FLOW_FILES) \$(AD_FILES) > svd_input_code.f
1395    
1396    svd_taf_output.f: svd_input_code.f
1397            \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) svd_input_code.f
1398            cat svd_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f
1399    
1400    svd_taf: svd_taf_output.o \$(OBJFILES)
1401            \$(LINK) -o ${EXE_SVD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)
1402    
1403    
1404    #=========================================
1405    
1406  EOF  EOF
1407    
1408  if test "x$EXEHOOK" != x ; then  if test "x$EXEHOOK" != x ; then
# Line 1253  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1439  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1439    
1440  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1441    
1442    #  Write the "template" files for the adjoint builds
1443    cat >AD_CONFIG.template <<EOF
1444    C  WARNING: This file is automatically generated by genmake2 and
1445    C    used by the Makefile rules.  Please DO NOT EDIT this file
1446    C    unless you are CERTAIN that you know what you are doing.
1447    
1448    #undef ALLOW_ADJOINT_RUN
1449    #undef ALLOW_TANGENTLINEAR_RUN
1450    #undef ALLOW_ECCO_OPTIMIZATION
1451    EOF
1452    cat >ad_config.template <<EOF
1453    C  WARNING: This file is automatically generated by genmake2 and
1454    C    used by the Makefile rules.  Please DO NOT EDIT this file
1455    C    unless you are CERTAIN that you know what you are doing.
1456    
1457    #define ALLOW_ADJOINT_RUN
1458    #undef ALLOW_TANGENTLINEAR_RUN
1459    #undef ALLOW_ECCO_OPTIMIZATION
1460    EOF
1461    cat >ftl_config.template <<EOF
1462    C  WARNING: This file is automatically generated by genmake2 and
1463    C    used by the Makefile rules.  Please DO NOT EDIT this file
1464    C    unless you are CERTAIN that you know what you are doing.
1465    
1466    #undef ALLOW_ADJOINT_RUN
1467    #define ALLOW_TANGENTLINEAR_RUN
1468    #undef ALLOW_ECCO_OPTIMIZATION
1469    EOF
1470    cat >svd_config.template <<EOF
1471    C  WARNING: This file is automatically generated by genmake2 and
1472    C    used by the Makefile rules.  Please DO NOT EDIT this file
1473    C    unless you are CERTAIN that you know what you are doing.
1474    
1475    #undef ALLOW_ADJOINT_RUN
1476    #undef ALLOW_TANGENTLINEAR_RUN
1477    #undef ALLOW_ECCO_OPTIMIZATION
1478    EOF
1479    cp AD_CONFIG.template AD_CONFIG.h
1480    
1481    
1482  #  Write the "state" for future records  #  Write the "state" for future records
1483  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then

Legend:
Removed from v.1.12  
changed lines
  Added in v.1.28

  ViewVC Help
Powered by ViewVC 1.1.22